/*
 * Copyright 2004-2006 Robbie.JP
 */
package robbie.dao;

import java.util.Map;
import java.util.List;
import java.util.Iterator;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.SQLException;


/**
 * DAÕx[XNXB<p>
 * ̃NXɂpublic\bh͎Ă܂B
 * ̃NX͕KpĂApKv܂B<br>
 * g̕@́ÃpbP[WSampleDAOсAXDAO̎mFĉB
 * @see robbie.dao.x.XDao
 * @see robbie.dao.s.SDao
 */
public class BaseDao implements java.io.Serializable {
    
    private static final long serialVersionUID = -3734013538684469448L;
    
    /** Connectiontransient錾 */
    transient private Connection conn = null;
    
    /**
     * ConnectionIuWFNgԂB<p>
     * @return ftHgłsetConnection()ŃZbgꂽConnection
     */
    protected Connection getConnection() {
         return this.conn;
    }
    
    /**
     * RlNVZbg<p>
     * ̃NX̓RlNV̎擾s܂B
     * TuNXŃRlNV쐬Ã\bhgăZbgĂB
     * @param conn TuNXō쐬Connection
     */
    protected void setConnection(Connection conn) throws SQLException {
        
        closeConnection();
        this.conn = conn;
    }
    
    /**
     * RlNVN[YB<p>
     * @throws SQLException
     */
    protected void closeConnection() throws SQLException {
        
        if (getConnection() != null) {
            getConnection().close();
            this.conn = null;
        }
    }
    
    /**
     * RlNVJĂ邩ǂ`FbN܂B<p>
     * JTAɂăgUNVǗĂꍇɂ́A
     * ̃\bhgpƖ肪ꍇ܂B
     * @return ConnectionI[vĂtrue
     * @throws SQLException
     */
    protected boolean isClosed() throws SQLException {
        
        if (getConnection() != null) {
            return getConnection().isClosed();
        } 
        return false;
    }
    
    /**
     * AutoCommit[hZbg܂B<p>
     * JDBC̎dlł́AConnection擾ۂɂ́AftHgAutoCommit[h
     * trueɂȂ܂BāAGȃgUNVsȂA
     * [obNAR~bg𑽗pꍇɂ́A炩߃I[gR~bg
     * falseɐݒ肵ĂKv܂B<p>
     * ܂AJTAɂăgUNVǗĂꍇɂ́A
     * ̃\bhgpƖ肪ꍇ܂B
     * @param isAutoCommit Lɂꍇɂtrue
     * @throws SQLException
     */
    protected void setAutoCommit(boolean isAutoCommit) throws SQLException {
        
        if (!isClosed()) {
            getConnection().setAutoCommit(isAutoCommit);
        }
    }
    
    /**
     * R~bgB<p>
     * JTAɂăgUNVǗĂꍇɂ́A
     * ̃\bhgpƖ肪ꍇ܂B
     * @throws SQLException
     */
    protected void commit() throws SQLException {
        
        if (!isClosed()) {
            getConnection().commit();
        }
    }

    /**
     * [obNB<p>
     * JTAɂăgUNVǗĂꍇɂ́A
     * ̃\bhgpƖ肪ꍇ܂B
     * @throws SQLException
     */
    protected void rollback() throws SQLException {
        
        if (!isClosed()) {
            getConnection().rollback();
        }
    }
    
    /**
     * ₢킹sAʂMapListŕԂ܂B<p>
     * ResultSetStatementClose͍s܂ARlNVCloses܂B
     * 
     * <pre>
     * gpF
     * ̃\bhgpꍇɂ́ATuNXňȉ̂悤ɁA
     * RlNV̎擾close()ǗȂA
     * Kv܂B
     * 
     * try {
     *     // 炩̎gpāAI[vꂽ
     *     // ConnecionIuWFNgZbg܂B
     *     setConnection(dataSource.getConnection());
     *     
     *     // QuerỹIuWFNgnĖ⍇s
     *     List result = executeQuery(query):
     *     
     *     ...炩̏ʂ̖⍇
     *     
     * } finally {
     * @@// closeConnection()ŕKConnectionBcloseConnection()
     * @@// ConnectionIuWFNgnullłΉȂB
     *     closeConnection();
     * }
     * 
     * </pre>
     * @see #closeConnection()
     * @param query QueryIuWFNg
     * @return List MapList
     * @throws SQLException
     */
    protected List executeQuery(Query query) throws SQLException {
        
        PreparedStatement sts = null;
        ResultSet rs = null;
        try {
            sts = openStatement(query.getSQLString());
            rs = openQuery(sts, query.getBindParametersMapList());
            return DaoUtil.resultSetToMapList(rs);
        } finally {
            closeQuery(sts, rs);
        }
    }
    
    /**
     * ₢킹sAʂObject[][]ŕԂ܂B<p>
     * Object[0][*]̓J̃wb_ɂȂ܂B
     * f[^gpꍇɂ́AObject[1][*]gpĂ
     * @see #executeQuery(Query)
     * @param query QueryIuWFNg
     * @return ʂ̂Qz
     * @throws SQLException
     */
    protected Object[][] executeQueryForArray(Query query) throws SQLException {
        
        PreparedStatement sts = null;
        ResultSet rs = null;
        try {
            sts = openStatement(query.getSQLString());
            rs = openQuery(sts, query.getBindParametersMapList());
            return DaoUtil.resultSetToArray(rs);
        } finally {
            closeQuery(sts, rs);
        }
    }
    
    /**
     * ₢킹sAʂJavaBeansListŕԂ܂B<p>
     * @param query QueryIuWFNg
     * @param beanClass TODO
     * @return ʂJavaBeansList
     * @throws SQLException
     */
    protected List executeQueryForBeans(Query query, Class beanClass) throws SQLException {
        
        PreparedStatement sts = null;
        ResultSet rs = null;
        try {
            sts = openStatement(query.getSQLString());
            rs = openQuery(sts, query.getBindParametersMapList()); 
            return DaoUtil.resultSetToBeansList(beanClass, rs);
        } catch(Exception ex){
            if (ex instanceof SQLException) {
                throw (SQLException)ex;
            }
            throw new DaoSysException(ex);
        } finally {
            closeQuery(sts, rs);
        }
    }
    
    /**
     * XVs܂B<p>
     * StatementClose͍s܂ARlNVClose͍s܂B
     * <pre>
     * gpF
     * ̃\bhgpꍇɂ́ATuNXňȉ̂悤ɁA
     * RlNV̎擾close()ǗȂA
     * Kv܂B
     * 
     * try {
     *     // 炩̎gpāAI[vꂽ
     *     // ConnecionIuWFNgZbg܂B
     *     setConnection(dataSource.getConnection());
     *     
     *     // SQL̃IuWFNgnčXVs
     *     int count = executeUpdate(query):
     *     
     *     // ƂāAXVsȂĂtrueA
     *     // 1sXVĂȂfalseԂ
     *     if(count > 0) {
     *         return true;
     *     }
     *     return false;
     *     
     * } finally {
     *     // closeConnection()ŕKConnectionBcloseConnection()
     *     // ConnectionIuWFNgnullłΉȂB
     *     closeConnection();
     * }
     * 
     * </pre>
     * ܂ÃNXStatementĂ܂߁ASQL͍ėpł܂B<p>
     * ob`̂悤SQLėp邽߂ɂ́ATuNXopenStatement()
     * bindParameters()ȂǂAPI𗘗pčĎKv܂B<p>
     * 
     * @see #closeConnection()
     * @param query QueryNX
     * @return XV
     * @throws SQLException
     */
    protected int executeUpdate(Query query) throws SQLException {
        
        int count = 0;
        PreparedStatement sts = null;
        try {
            String sqlStr = query.getSQLString();
            List params = query.getBindParametersMapList();
            sts = openStatement(sqlStr);
            bindParameters(sts, params);
            count = sts.executeUpdate();
        } finally {
            closeStatement(sts);
        }
        return count;
    }
    
    /**
     * StatementCX^XԂ܂B<p>
     * p@openQuery()̎gpmFĂB
     * @see #openQuery(PreparedStatement sts, List params)
     * @param sql SQLNX
     * @return PreparedStatementIuWFNg
     * @throws SQLException
     */
    protected PreparedStatement openStatement(String sql) throws SQLException {
        return getConnection().prepareStatement(sql);
    }
    
    /**
     * sAResultSetԂ܂B<p>
     * executeQuerýAʂMapListŕԂ܂Ã\bhł́A
     * openꂽStatementɃoChϐZbgāAResultSet
     * Ԃ܂B<p>
     * <pre>
     * gpF
     * ̃\bhgpꍇɂ́ATuNXňȉ̂悤ɁA
     * PreparedStatementAResultSetAConnection̎擾close()A
     * SQLNXǗȂAKv܂B
     * 
     * PreparedStatement statement = null;
     * ResultSet reslut = null;
     * try {
     *     // 炩̎gpāAI[vꂽ
     *     // ConnecionIuWFNgZbg܂B
     *     setConnection(dataSource.getConnection());
     *     
     *     // QuerỹIuWFNgSQLoChϐMapList
     *     // o܂B
     *     String sqlStr = query.getSQLString();
     *     List params = query.getBindParametersMapList();
     *     
     *     // StatementOPENASQLsResultSet擾܂B
     *     statement = openStatement(sqlStr);
     *     result = openQuery(statement, params);
     *     
     *     // ResutlSetgpĉ̏sȂ܂B
     *     
     *     EEEEE
     *     
     * } finally {
     *     // KPreparedStatementAResultSetAConnection
     *     // ܂B
     *     try {
     *         closeQuery(statement, reslut);
     *     } finally {
     *         closeConnection();
     *     }
     * }
     * 
     * </pre>
     * @see #openStatement(String sql)
     * @see #bindParameters(PreparedStatement sts, List params)
     * @see #closeQuery(PreparedStatement sts, ResultSet rs)
     * @see #closeConnection()
     * @param sts I[vStatement
     * @param params SQLbpIuWFNg
     * @return sResultSet
     * @throws SQLException
     */
    protected ResultSet openQuery(PreparedStatement sts, List params) 
            throws SQLException {
        
        bindParameters(sts, params);
        return sts.executeQuery();
    }
    
    /**
     * PreparedStatemanetMapList̃p[^oChĂ܂B<p>
     * ̃\bhopenQueryďoĂ܂B
     * <pre>
     * openQuery̎́Aȉ̂悤ɂȂĂ܂B
     * 
     *      protected ResultSet openQuery(PreparedStatement sts, List params) 
     *              throws SQLException {
     *          
     *          bindParameters(sts, params);
     *          return sts.executeQuery();
     *      }
     * 
     * L̂悤openꂽXe[ggɐVɃp[^ZbgāA
     * SQLsĂ܂B
     * 
     * pF
     * openQuery()̎QlɁAsp[^̔zpӂ
     * ȉ̂悤ɏsȂ΁Aob`IɃf[^x[X
     * XV邱Ƃ\ɂȂ܂B
     * 
     *      for(int i=0; i&lt;params.length; i++) {
     *          bindParameters(sts, params[i]);
     *          sts.executeUpdate();
     *      }
     * 
     *      *) paramśAList̔zƂ
     * 
     * </pre>
     * @see #openQuery(PreparedStatement sts, List params)
     * @param sts openĂPrepaedStatement
     * @param params oChϐMapList
     * @throws SQLException
     */
    protected void bindParameters(PreparedStatement sts, List params) 
            throws SQLException {
        
        if (params != null) {
            int i=1;
            for(Iterator it = params.iterator(); it.hasNext(); i++) {
                Map map = (Map)it.next();
                Object obj = map.get(DaoKeys.VALUE_KEY);
                Integer type = (Integer)map.get(DaoKeys.TYPE_KEY);
                if (obj != null) {
                    sts.setObject(i,obj);
                } else {
                    if(type == null) {
                        sts.setNull(i, java.sql.Types.VARCHAR);
                    } else {
                        sts.setNull(i, type.intValue());
                    }
                }
            }
        }
    }
    
    /**
     * ܂B<p>
     * ۂɂResultSetPreparedStatementclose()Ă܂B
     * p@openQuery()̎gpmFĂB
     * @see #openQuery(PreparedStatement sts, List params)
     * @param sts openĂPrepaedStatement
     * @param rs openĂResultSet
     * @throws SQLException
     */
    protected void closeQuery(PreparedStatement sts, ResultSet rs) 
            throws SQLException {
        
        closeResultSet(rs);
        closeStatement(sts);
    }
    
    /**
     * StatementCX^X܂B<p>
     * @param sts openĂPrepaedStatemen
     * @throws SQLException
     */
    protected void closeStatement(PreparedStatement sts) throws SQLException {
        
        if (sts != null) {
            sts.close();
        }
    }
    
    /**
     * ResultSetCX^X܂B<p>
     * @param rs openĂResultSet
     * @throws SQLException
     */
    protected void closeResultSet(ResultSet rs) throws SQLException {
        
        if (rs != null) {
            rs.close();
        }
    }
}
